df2mstrl <- function(data, coords.col=1:2, dates.col=3,
                     data.col=4:ncol(data), dates.form="yyyy/mm/dd") {
  for (i in coords.col[2:1]) 
    data <- data[sort(data[,i], method="quick", index.return=TRUE)$ix,]
  dates <- .ISOdate(as.character(data[,dates.col]), form=dates.form)
  ord <- order(dates)
  data <- data[ord, ]
  dates <- unique(dates)
  dates <- dates[order(dates)]
  x <- sort(unique(data[,coords.col[1]]))
  y <- sort(unique(data[,coords.col[2]]))
  dddd <- c(length(x), length(y), length(dates), length(data.col))
  new("mstrl",
      coords=new("rlcoords", x=x, y=y),
      dates=dates,
      data=new("strldata",
        value=array(as.matrix(data[, data.col]), dddd,
          dimnames=list(1:dddd[1], 1:dddd[2], dates,
            colnames(data)[data.col]))))
}
