.extract.border <-
function(obj, bor) {
  if (bor>0) {
    dd <- dim(obj)
    ebor <- function(mat) {
      for (i in 1:bor) {
        mat <- mat[-c(1,nrow(mat)), ]
        mat <- mat[, -c(1,ncol(mat))]
      }
      return(mat)
    }
    if (length(dd)==3) {
      res <- array(0, dd-c(2*bor, 2*bor, 0))
      for (i in 1:dd[3])
        res[,,i] <- ebor(obj[,,i])
    }
    else
      res <- ebor(obj)
    return(res)
  }
  return(obj)
}

.ISOdate <- function (date, form = c("yyyy/mm/dd",
                              "mm/dd/yyyy", "dd/mm/yyyy",
                              "yyyy/dd/mm", "date", "numeric")) {
  form <- match.arg(form)
  if (form == "dd/mm/yyyy") 
    return(ISOdate(substr(date, 7, 10), substr(date, 4, 5), 
                   substr(date, 1, 2)))
  if (form == "mm/dd/yyyy") 
    return(ISOdate(substr(date, 7, 10), substr(date, 1, 2), 
                   substr(date, 4, 5)))
  if (form == "yyyy/mm/dd") 
    return(ISOdate(substr(date, 1, 4), substr(date, 6, 7), 
                   substr(date, 9, 10)))
  if (form == "yyyy/dd/mm") 
    return(ISOdate(substr(date, 1, 4), substr(date, 9, 10), 
                   substr(date, 6, 7)))
  if (form == "numeric") {
    date <- as.numeric(date)
    class(date) <- "date"
    form <- "date"
  }
  if (form == "date") {
    if (!require(date)) 
      cat("there is no package called 'date',\n callet a package!\n")
    M <- c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", 
           "Aug", "Sep", "Oct", "Nov", "Dec")
    nM <- 1:12
    chd <- as.character(date)
    nch <- nchar(chd)
    m <- substr(chd, nch - 6, nch - 4)
    nm <- nM[sapply(m, function(x, y)
                    which(is.element(y, x)), M)]
    return(ISOdate(substr(chd, nch - 3, nch),
                   nm, substr(chd, 1, nch - 7)))
  }
}
