#include <stdio.h>
#include <stdlib.h> /* for malloc & free */
#include "memory.h"
#include <math.h>
#include <R.h>
#include <Rmath.h>

void rautobin(int *resp, double *covar, double *coefs, 
	      int *I, int *J, int *T, int *ord) {
  int I2, J2, i, j, y1, y2, y3, y4, itemp, itemp2, t;
  double eta, p;
  I2 = *I-2;
  J2 = *J-2;

  GetRNGstate();
  itemp2 = (*I)*(*J);

  for (i=1; i<=I2; i++) {
    for (j=1; j<=J2; j++) {
      itemp = ord[i-1+(j-1)*I2];
      y1 = resp[itemp-*I] + resp[itemp+*I];
      y2 = resp[itemp-1] + resp[itemp+1];
      y3 = resp[itemp-1-*I] + resp[itemp+1+*I];
      y4 = resp[itemp-1+*I] + resp[itemp+1-*I];
      eta = coefs[0] + coefs[1]*(float)y1 + 
	coefs[2]*(float)y2 + coefs[3]*(y1+y2) +
	coefs[4]*(float)y3 + coefs[5]*(float)y4 +
	coefs[6]*(y3+y4) + coefs[7]*(y1+y2+y3+y4);
      for (t=0; t<*T; t++) 
	eta += covar[itemp+t*itemp2]*coefs[t+8];
      p = 1/(1+exp(-eta));
      resp[itemp] = rbinom(1,p);
    }
  }
  
  PutRNGstate();
}

